"use strict";

exports.__esModule = true;
exports.default = void 0;

var _rax = require("rax");

var _raxImage = _interopRequireDefault(require("rax-image"));

var _formatStyle = _interopRequireDefault(require("./formatStyle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var Picture = (0, _rax.forwardRef)(function (props, ref) {
  var children = props.children,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style,
      source = props.source,
      resizeMode = props.resizeMode,
      width = props.width,
      height = props.height,
      defaultHeight = props.defaultHeight,
      rest = __rest(props, ["children", "style", "source", "resizeMode", "width", "height", "defaultHeight"]);

  var formatedStyle = (0, _formatStyle.default)(style);
  var styleWidth = formatedStyle.width; // style width of picture

  var styleHeight = formatedStyle.height; // style width of picture
  // according to the original height and width of the picture

  if (!styleHeight && styleWidth && width && height) {
    var pScaling = width / (typeof styleWidth === 'string' ? parseInt(styleWidth, 10) : styleWidth);
    styleHeight = parseInt(height / pScaling + '', 10);
  }

  if (!styleHeight) {
    styleHeight = defaultHeight;

    if (!resizeMode) {
      // ensure that the picture can be displayed
      resizeMode = 'contain';
    }
  }

  var newStyle = Object.assign({
    height: styleHeight
  }, style);

  if (resizeMode) {
    newStyle.resizeMode = resizeMode;
  }

  return (0, _rax.createElement)(_raxImage.default, _extends({}, rest, {
    ref: ref,
    source: source,
    style: newStyle
  }), children);
});
Picture.displayName = 'Picture';
var _default = Picture;
exports.default = _default;